Index: drivers/s390/block/dasd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -3564,50 +4406,57 @@
         }
         goto out;
  bringup_fail:   /* revert changes */
-#if 0
-        printk (KERN_DEBUG PRINTK_HEADER
-                "failed to set device from state %d to %d at "
-                "level %d rc %d. Reverting...\n",
-                from_state,
-                to_state,
-                device->level,
-                rc);
-#endif
-        to_state = from_state;
-        from_state = device->level;
+
+        DBF_DEV_EVENT (DBF_ERR, device,
+                       "failed to set device from state %d to %d at "
+                       "level %d rc %d. Reverting...",
+                       from_state,
+                       to_state,
+                       device->level,
+                       rc);
+
+        if (device->level <= DASD_STATE_NEW) {
+                /* Revert - device can not be accessed */
+                to_state = from_state;
+                from_state = device->level;
+        }
         
         /* now do a shutdown */
  shutdown: 
-        if ( from_state >= DASD_STATE_ONLINE &&
+        if ( device->level >= DASD_STATE_ONLINE &&
              to_state <= DASD_STATE_READY ) 
                 if (dasd_state_online_to_ready(device))
                         BUG();
 
-        if ( from_state >= DASD_STATE_READY &&
+        if ( device->level >= DASD_STATE_READY &&
              to_state <= DASD_STATE_ACCEPT ) 
                 if ( dasd_state_ready_to_accept(device))
                         BUG();
 
-        if ( from_state >= DASD_STATE_ACCEPT &&
+        if ( device->level >= DASD_STATE_ACCEPT &&
              to_state <= DASD_STATE_KNOWN ) 
                 if ( dasd_state_accept_to_known(device))
                         BUG();
 
-        if ( from_state >= DASD_STATE_KNOWN &&
+        if ( device->level >= DASD_STATE_KNOWN &&
              to_state <= DASD_STATE_NEW ) 
                 if ( dasd_state_known_to_new(device))
                         BUG();
 
-        if ( from_state >= DASD_STATE_NEW &&
+        if ( device->level >= DASD_STATE_NEW &&
              to_state <= DASD_STATE_DEL) 
-                if (dasd_state_new_to_del(device_addr))
+                if (dasd_state_new_to_del(device_addr, devno))
                         BUG();
         goto out;
  out:
         return rc;
 }
 
-/* SECTION: Procfs stuff */
+/********************************************************************************
+ * SECTION: Procfs stuff 
+ ********************************************************************************/
+#ifdef CONFIG_PROC_FS
+
 typedef struct {
 	char *data;
 	int len;
@@ -3640,29 +4489,53 @@
         int index = 0;
 
         MOD_INC_USE_COUNT;
-        spin_lock_irqsave(&discipline_lock,flags);
+
+        spin_lock_irqsave(&discipline_lock,
+                          flags);
+
 	info = (tempinfo_t *) vmalloc (sizeof (tempinfo_t));
+
 	if (info == NULL) {
-                printk (KERN_WARNING "No memory available for data\n");
+
+                MESSAGE (KERN_WARNING, "%s",
+                         "No memory available for data (tempinfo)");
+
+                spin_unlock_irqrestore(&discipline_lock,
+                                       flags);
+
                 MOD_DEC_USE_COUNT;
+
                 return -ENOMEM;
+
 	} else {
 		file->private_data = (void *) info;
 	}
-	list_for_each (l, &dasd_major_info[0].list) {
+	list_for_each (l, &dasd_major_info) {
                 size += 128 * 1 << (MINORBITS - DASD_PARTN_BITS);
 	}
 	info->data = (char *) vmalloc (size);	
-	DASD_DRIVER_DEBUG_EVENT (1, dasd_devices_open, "area: %p, size 0x%x",
-				 info->data, 
-                                 size);
+
 	if (size && info->data == NULL) {
-		printk (KERN_WARNING "No memory available for data\n");
+
+		MESSAGE (KERN_WARNING, "%s",
+                         "No memory available for data (info->data)");
+
 		vfree (info);
+
+                spin_unlock_irqrestore(&discipline_lock,
+                                       flags);
+
                 MOD_DEC_USE_COUNT;
+
 		return -ENOMEM;
 	}
-	list_for_each (l, &dasd_major_info[0].list) {
+
+	DBF_EVENT (DBF_NOTICE,
+                   "procfs-area: %p, size 0x%x allocated",
+                   info->data, 
+                   size);
+
+	list_for_each (l, &dasd_major_info) {
 		temp = list_entry (l, major_info_t, list);
 		for (i = 0; i < 1 << (MINORBITS - DASD_PARTN_BITS); i++) {
 			dasd_device_t *device;
@@ -3673,8 +4546,8 @@
                                 continue;
 
                         features = dasd_features_from_devno(devno);
-                        if (features < DASD_DEFAULT_FEATURES)
-                                features = DASD_DEFAULT_FEATURES;
+                        if (features < DASD_FEATURE_DEFAULT)
+                                features = DASD_FEATURE_DEFAULT;
 
                         device = temp->dasd_device[i];
 			if (device) {
@@ -3702,45 +4575,45 @@
 					    sprintf (info->data + len,
 						     "detected");
 					break;
+				case DASD_STATE_BOXED:
+					len +=
+					    sprintf (info->data + len,
+						     "boxed");
+					break;
 				case DASD_STATE_ACCEPT:
-                                        len += sprintf (info->data + len,"accepted");
+                                        len += sprintf (info->data + len,
+                                                        "accepted");
 					break;
 				case DASD_STATE_INIT:
-					len +=
-					    sprintf (info->data + len,
-						     "busy   ");
+					len += sprintf (info->data + len,
+                                                        "busy   ");
 					break;
 				case DASD_STATE_READY:
+					len += sprintf (info->data + len,
+							"ready  ");
+					break;
 				case DASD_STATE_ONLINE:
-                                    if ( atomic_read(&device->plugged) )
-                                        len +=
-                                            sprintf (info->data + len,
-                                                     "fenced ");
-                                    else
-                                        len +=
-                                            sprintf (info->data + len,
-                                                     "active ");
-                                    if ( device->sizes.bp_block == 512 ||
-                                         device->sizes.bp_block == 1024 ||
-                                         device->sizes.bp_block == 2048 ||
-                                         device->sizes.bp_block == 4096 )
-					len +=
-					    sprintf (info->data + len,
-						     "at blocksize: %d, %ld blocks, %ld MB",
-						     device->sizes.bp_block,
-						     device->sizes.blocks,
-						     ((device->
-						       sizes.bp_block >> 9) *
-						      device->sizes.
-						      blocks) >> 11);
-                                    else
-                                        len +=
-                                            sprintf (info->data + len,
-                                                     "n/f    ");
+                                        len += sprintf (info->data + len,
+                                                        "active ");
+
+                                        if (dasd_check_bp_block (device))
+                                                len +=
+                                                    sprintf (info->data + len,
+                                                             "n/f    ");
+                                        else
+                                                len +=
+                                                    sprintf (info->data + len,
+                                                             "at blocksize: %d, %ld blocks, %ld MB",
+                                                             device->sizes.bp_block,
+                                                             device->sizes.blocks,
+                                                             ((device->
+                                                               sizes.bp_block >> 9) *
+                                                              device->sizes.
+                                                              blocks) >> 11);
 					break;
 				default:
 					len +=
-					    sprintf (info->data + len,
+                                            sprintf (info->data + len,
 						     "no stat");
 					break;
 				}
@@ -3769,7 +4642,9 @@
                 index += 1 << (MINORBITS - DASD_PARTN_BITS);
 	}
 	info->len = len;
-        spin_unlock_irqrestore(&discipline_lock,flags);
+
+        spin_unlock_irqrestore(&discipline_lock,
+                               flags);
 	return rc;
 }
 
@@ -3793,22 +4668,250 @@
 	}
 }
 
+/* 
+ * scan for device range in given string (e.g. 0x0150-0x0155).
+ * devnos are always hex and leading 0x are ignored.
+ */
+static char *
+dasd_parse_range (char *buffer, dasd_range_t *range)
+{
+        char *str;
+
+        /* remove optional 'device ' and 'range=' and search for nexet digit */
+        for (str = buffer + 4; isspace(*str); str++);
+
+	if (strncmp (str, "device ", 7) == 0) 
+		for (str = str + 7; isspace(*str); str++);
+        
+	if (strncmp (str, "range=", 6) == 0) 
+                for (str = str + 6; isspace(*str); str++);
+        
+        range->to = range->from = dasd_strtoul (str, 
+                                                &str, 
+                                                &(range->features));
+        
+        if (*str == '-') {
+		str++;
+		range->to = dasd_strtoul (str, 
+                                          &str, 
+                                          &(range->features));
+	}
+        
+        /* remove blanks after device range */
+	for (; isspace(*str); str++);
+
+        if (range->from < 0 || range->to < 0) {
+                MESSAGE_LOG (KERN_WARNING,
+                             "/proc/dasd/devices: range parse error in '%s'", 
+                             buffer);
+                return ERR_PTR (-EINVAL);
+        }
+
+        return str;
+
+} /* end dasd_parse_range */
+
+/* 
+ * Enable / Disable the given devices  
+ */
+static void
+dasd_proc_set (char *buffer)
+{
+	dasd_range_t range;
+        char *str;
+
+        str = dasd_parse_range (buffer, 
+                                &range);
+        
+        /* Negative numbers in str/from/to indicate errors */
+        if (IS_ERR (str) || (range.from < 0) || (range.to < 0)
+            || (range.from > 0xFFFF) || (range.to > 0xFFFF)) 
+                return;
+
+        if (strncmp (str, "on", 2) == 0) {
+                dasd_enable_ranges (&range, NULL, 0);
+
+        } else if (strncmp (str, "off", 3) == 0) {
+                dasd_disable_ranges (&range, NULL, 0, 1);
+                
+        } else {
+                MESSAGE_LOG (KERN_WARNING,
+                             "/proc/dasd/devices: "
+                             "only 'on' and 'off' are alowed in 'set' "
+                             "command ('%s'/'%s')",
+                             buffer,
+                             str);
+        }
+
+        return;
+
+} /* end dasd_proc_set */
+
+/* 
+ * Add the given devices
+ */
+static void
+dasd_proc_add (char *buffer)
+{
+	dasd_range_t range;
+        char *str;
+        
+        str = dasd_parse_range (buffer, 
+                                &range);
+        
+        /* Negative numbers in str/from/to indicate errors */
+        if (IS_ERR (str) || (range.from < 0) || (range.to < 0)
+            || (range.from > 0xFFFF) || (range.to > 0xFFFF))
+                return;
+
+        dasd_add_range (range.from, range.to, range.features);
+        dasd_enable_ranges (&range, NULL, 0);
+
+        return;
+
+} /* end dasd_proc_add */
+
+/* 
+ * Break the lock of a given 'boxed' dasd.
+ * If the dasd in not in status 'boxed' just return.  
+ */
+static int
+dasd_break_boxed (dasd_range_t  *range,
+                  dasd_device_t *device)
+{
+        int rc = 0;
+        dasd_discipline_t *discipline;
+        struct list_head  *lh = dasd_disc_head.next;
+                
+        /* check devixe status */
+        if (device->level != DASD_STATE_BOXED) {
+                MESSAGE (KERN_WARNING,
+                         "/proc/dasd/devices: the given device (%04X) "
+                         "is not 'boxed')",
+                         device->devinfo.devno);
+                rc = -EINVAL;
+                goto out; 
+        }
+
+        /* force eckd discipline */
+        do {
+                discipline = list_entry(lh,
+                                        dasd_discipline_t,
+                                        list);
+                
+                if (strncmp (discipline->name, range->discipline, 4) == 0)
+                        break;  /* discipline found */
+                
+                lh = lh->next;    /* check next discipline in list */
+                if (lh == &dasd_disc_head) {
+                        discipline = NULL;
+                        break;
+                }
+        } while ( 1 );
+        device->discipline = discipline;
+
+        if (device->discipline == NULL) {
+                MESSAGE (KERN_WARNING, "%s",
+                         "/proc/dasd/devices: discipline not found "
+                         "in discipline list");
+                rc = -EINVAL;
+                goto out;
+        }
+
+        /* register the int handler to enable IO */
+        rc = s390_request_irq_special (device->devinfo.irq,
+                                       device->discipline->int_handler,
+                                       dasd_not_oper_handler,
+                                       SA_DOPATHGROUP | SA_FORCE, 
+                                       DASD_NAME,
+                                       &device->dev_status);
+        if ( rc ) 
+                goto out;
+
+	rc = dasd_steal_lock (device);
+
+        /* unregister the int handler to enable re-sensing */
+        free_irq (device->devinfo.irq, 
+                  &device->dev_status);
+        
+        device->discipline = NULL;
+        device->level      = DASD_STATE_NEW;
+
+ out:
+        return rc;
+
+} /* end dasd_break_boxed */
+
+/* 
+ * Handle the procfs call 'brk <devno> <discipline>.
+ */
+static void
+dasd_proc_brk (char *buffer)
+{
+	char *str;
+	dasd_range_t range;
+        dasd_device_t *device;
+        int rc = 0;
+
+        str = dasd_parse_range (buffer,
+                                 &range);
+
+        if (IS_ERR (str))
+                return;
+
+        if (range.from != range.to) {
+                MESSAGE (KERN_WARNING, "%s",
+                         "/proc/dasd/devices: 'brk <devno> <discipline> "
+                         "is only allowed for a single device (no ranges)");
+                return;
+        }
+
+        /* check for discipline = 'eckd' */
+        if (strncmp(str, "eckd", 4) != 0) {
+                MESSAGE_LOG (KERN_WARNING,
+                             "/proc/dasd/devices: 'brk <devno> <discipline> "
+                             "is only allowed for 'eckd' (%s)",
+                             str);
+                return;
+        }
+        
+        memcpy (range.discipline, "ECKD", 4);
+
+	device = *(dasd_device_from_devno (range.from));
+        if (device == NULL) {
+                MESSAGE (KERN_WARNING,
+                         "/proc/dasd/devices: no device found for devno (%04X)",
+                         range.from);
+                return;
+        }
+        
+        rc = dasd_break_boxed (&range, 
+                               device);
+        if (rc == 0) {
+                /* trigger CIO to resense the device */
+                s390_trigger_resense (device->devinfo.irq);
+                
+                // get the device online now
+                dasd_enable_ranges (&range, 
+                                    NULL, 
+                                    0);
+        }
+        
+} /* end dasd_proc_brk */
+
 static ssize_t
 dasd_devices_write (struct file *file, const char *user_buf,
 		    size_t user_len, loff_t * offset)
 {
 	char *buffer;
-	int off = 0;
-	char *temp;
-	dasd_range_t range;
-        int features;
 
 	if (user_len > PAGE_SIZE)
 		return -EINVAL;
-		
+
 	buffer = vmalloc (user_len+1);
 	if (buffer == NULL)
 		return -ENOMEM;
+
 	if (copy_from_user (buffer, user_buf, user_len)) {
 		vfree (buffer);
 		return -EFAULT;
@@ -3821,60 +4924,29 @@
                 buffer[user_len] = '\0';
         }
 
-	printk (KERN_INFO PRINTK_HEADER "/proc/dasd/devices: '%s'\n", buffer);
-	if (strncmp (buffer, "set ", 4) && strncmp (buffer, "add ", 4)) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"/proc/dasd/devices: only 'set' and 'add' are supported verbs\n");
-		return -EINVAL;
-	}
-	off += 4;
-	while (buffer[off] && !isalnum (buffer[off]))
-		off++;
-	if (!strncmp (buffer + off, "device", strlen ("device"))) {
-		off += strlen ("device");
-		while (buffer[off] && !isalnum (buffer[off]))
-			off++;
-	}
-	if (!strncmp (buffer + off, "range=", strlen ("range="))) {
-		off += strlen ("range=");
-		while (buffer[off] && !isalnum (buffer[off]))
-			off++;
-	}
-	
-	temp = buffer + off;
-	range.from = dasd_strtoul (temp, &temp, &features);
-	range.to = range.from;
-
-	if (*temp == '-') {
-		temp++;
-		range.to = dasd_strtoul (temp, &temp, &features);
-	}
+	MESSAGE_LOG (KERN_INFO,
+                     "/proc/dasd/devices: '%s'", 
+                     buffer);
+        
+	if (strncmp (buffer, "set ", 4) == 0) {
+                /* handle 'set <devno> on/off' */
+                dasd_proc_set (buffer);
+
+        } else if (strncmp (buffer, "add ", 4) == 0) {
+                /* handle 'add <devno>' */
+                dasd_proc_add (buffer);
+
+        } else if (strncmp (buffer, "brk ", 4) == 0) {
+                /* handle 'brk <devno> <discipline>' */
+                dasd_proc_brk (buffer);
 
-        if (range.from == -EINVAL ||
-            range.to   == -EINVAL   ) {
-                
-                printk (KERN_WARNING PRINTK_HEADER
-                        "/proc/dasd/devices: range parse error in '%s'\n", 
-                        buffer);
         } else {
-                off = (long) temp - (long) buffer;
-                if (!strncmp (buffer, "add", strlen ("add"))) {
-                        dasd_add_range (range.from, range.to, features);
-                        dasd_enable_ranges (&range, NULL, 0);
-                } else { 
-                        while (buffer[off] && !isalnum (buffer[off]))
-                                off++;
-                        if (!strncmp (buffer + off, "on", strlen ("on"))) {
-                                dasd_enable_ranges (&range, NULL, 0);
-                        } else if (!strncmp (buffer + off, "off", strlen ("off"))) {
-                                dasd_disable_ranges (&range, NULL, 0, 1);
-                        } else {
-                                printk (KERN_WARNING PRINTK_HEADER
-                                        "/proc/dasd/devices: parse error in '%s'\n",
-                                        buffer);
-                        }
-                }
-        }
+		MESSAGE (KERN_WARNING, "%s",
+                         "/proc/dasd/devices: only 'set' ,'add' and "
+                         "'brk' are supported verbs");
+		vfree (buffer);
+		return -EINVAL;
+	}
 
 	vfree (buffer);
 	return user_len;
@@ -3895,9 +4967,9 @@
 }
 
 static struct file_operations dasd_devices_file_ops = {
-	read:dasd_generic_read,	/* read */
+	read:dasd_generic_read,	        /* read */
 	write:dasd_devices_write,	/* write */
-	open:dasd_devices_open,	/* open */
+	open:dasd_devices_open,	        /* open */
 	release:dasd_devices_close,	/* close */
 };
 
@@ -3914,22 +4986,41 @@
 
         MOD_INC_USE_COUNT;
 	info = (tempinfo_t *) vmalloc (sizeof (tempinfo_t));
+
 	if (info == NULL) {
-		printk (KERN_WARNING "No memory available for data\n");
+ 
+		MESSAGE (KERN_WARNING, "%s",
+                         "No memory available for data (tempinfo)");
+
                 MOD_DEC_USE_COUNT;
 		return -ENOMEM;
 	} else {
 		file->private_data = (void *) info;
 	}
-	info->data = (char *) vmalloc (PAGE_SIZE);	/* FIXME! determine space needed in a better way */
+        /* FIXME! determine space needed in a better way */
+	info->data = (char *) vmalloc (PAGE_SIZE);	
+
 	if (info->data == NULL) {
-		printk (KERN_WARNING "No memory available for data\n");
+
+		MESSAGE (KERN_WARNING, "%s",
+                         "No memory available for data (info->data)");
+
 		vfree (info);
 		file->private_data = NULL;
                 MOD_DEC_USE_COUNT;
 		return -ENOMEM;
 	}
         
+        /* check for active profiling */
+        if (dasd_profile_level == DASD_PROFILE_OFF) {
+
+                info->len = sprintf (info->data, 
+                                     "Statistics are off - they might be "
+                                     "switched on using 'echo set on > "
+                                     "/proc/dasd/statistics'\n");
+                return rc;
+        } 
+
         /* prevent couter 'ouverflow' on output */
 	for (shift = 0, help = dasd_global_profile.dasd_io_reqs;
 	     help > 9999999; help = help >> 1, shift++) ;
@@ -3958,7 +5049,15 @@
 	}
 	len += sprintf (info->data + len, "\n");
 
-	len += sprintf (info->data + len, "Histogram of I/O times (microseconds)\n");
+	for (; i < 32; i++) {
+		len += sprintf (info->data + len, "%7d ",
+                                dasd_global_profile.dasd_io_secs[i] >> shift);
+	}
+	len += sprintf (info->data + len, "\n");
+
+	len += sprintf (info->data + len, 
+                        "Histogram of I/O times (microseconds)\n");
+
 	for (i = 0; i < 16; i++) {
 		len += sprintf (info->data + len, "%7d ",
                                 dasd_global_profile.dasd_io_times[i] >> shift);
@@ -4008,7 +5107,9 @@
 	len += sprintf (info->data + len, "\n");
 
 	len += sprintf (info->data + len,
-                        "Histogram of I/O time between ssch and irq per sector\n");
+                        "Histogram of I/O time between ssch and irq per "
+                        "sector\n");
+
 	for (i = 0; i < 16; i++) {
 		len += sprintf (info->data + len, "%7d ",
                                 dasd_global_profile.dasd_io_time2ps[i] >> shift);
@@ -4064,23 +5165,89 @@
 
 	if (buffer == NULL)
 		return -ENOMEM;
+
 	if (copy_from_user (buffer, user_buf, user_len)) {
 		vfree (buffer);
 		return -EFAULT;
 	}
+
 	buffer[user_len] = 0;
-	printk (KERN_INFO PRINTK_HEADER "/proc/dasd/statictics: '%s'\n",
-		buffer);
-	if (strncmp (buffer, "reset", 4)) {
-		memset (&dasd_global_profile, 0, sizeof (dasd_profile_info_t));
+        
+	MESSAGE (KERN_INFO,
+                 "/proc/dasd/statictics: '%s'",
+                 buffer);
+
+#ifdef DASD_PROFILE
+         /* check for valid verbs */
+	if (strncmp (buffer, "reset", 5) && 
+            strncmp (buffer, "set ",  4)   ) {
+
+		MESSAGE (KERN_WARNING, "%s",
+                         "/proc/dasd/statistics: only 'set' and "
+                         "'reset' are supported verbs");
+
+        	return -EINVAL;
 	}
+
+	if (!strncmp (buffer, "reset", 5)) {
+                
+                /* reset the statistics */
+		memset (&dasd_global_profile, 
+                        0, 
+                        sizeof (dasd_profile_info_t));
+                
+                MESSAGE (KERN_INFO, "%s",
+                         "Statictics reset");
+
+	} else {
+
+                /* 'set xxx' was given */
+                int offset = 4;
+
+                while (buffer[offset] && !isalnum (buffer[offset]))
+                        offset++;
+
+                if (!strncmp (buffer + offset, "on", 2)) {
+                        
+                        /* switch on statistics profiling */
+                        dasd_profile_level = DASD_PROFILE_ON;
+                        
+                        MESSAGE (KERN_INFO, "%s",
+                                 "Statictics switched on");
+                        
+                } else if (!strncmp (buffer + offset, "off", 3)) {
+                        
+                        /* switch off and reset statistics profiling */
+                        memset (&dasd_global_profile, 
+                                0, 
+                                sizeof (dasd_profile_info_t));
+                        
+                        dasd_profile_level = DASD_PROFILE_OFF;
+                        
+                        MESSAGE (KERN_INFO, "%s",
+                                 "Statictics switched off");
+
+                } else {
+
+                        MESSAGE (KERN_WARNING, "%s",
+                                 "/proc/dasd/statistics: only 'set on' and "
+                                 "'set off' are supported verbs");
+                } 
+        } 
+#else
+        MESSAGE (KERN_WARNING, "%s",
+                 "/proc/dasd/statistics: is not activated in this "
+                 "kernel");
+        
+
+#endif /* DASD_PROFILE */
 	return user_len;
 }
 
 static struct file_operations dasd_statistics_file_ops = {
-	read:dasd_generic_read,	/* read */
-	open:dasd_statistics_open,	/* open */
+	read:dasd_generic_read,	        /* read */
 	write:dasd_statistics_write,	/* write */
+	open:dasd_statistics_open,	/* open */
 	release:dasd_devices_close,	/* close */
 };
 
@@ -4113,6 +5280,11 @@
 	remove_proc_entry ("dasd", &proc_root);
 }
 
+#endif /* CONFIG_PROC_FS */
+
+/********************************************************************************
+ * SECTION: Initializing the driver 
+ ********************************************************************************/
 int
 dasd_request_module ( void *name ) {
 	int rc = -ERESTARTSYS;
@@ -4124,16 +5296,17 @@
 	} 
 	while ( (rc=request_module(name)) != 0 ) {
         	DECLARE_WAIT_QUEUE_HEAD(wait);
-		printk ( KERN_INFO "request_module returned %d for %s\n",
-                         rc,
-                         (char*)name);
+
+		MESSAGE_LOG (KERN_INFO,
+                             "request_module returned %d for %s",
+                             rc,
+                             (char*)name);
+
         	sleep_on_timeout(&wait,5* HZ); /* wait in steps of 5 seconds */
     	}
     	return rc;
 }
 
-
-/* SECTION: Initializing the driver */
 int __init
 dasd_init (void)
 {
@@ -4142,40 +5315,56 @@
 	major_info_t *major_info = NULL;
 	struct list_head *l;
 
-	printk (KERN_INFO PRINTK_HEADER "initializing...\n");
-	dasd_debug_area = debug_register (DASD_NAME, 0, 2, 5 * sizeof (long));
-	debug_register_view (dasd_debug_area, &debug_sprintf_view);
-	debug_register_view (dasd_debug_area, &debug_hex_ascii_view);
+	MESSAGE (KERN_INFO, "%s",
+                 "initializing...");
 
 	init_waitqueue_head (&dasd_init_waitq);
 
+        /* register 'common' DASD debug area, used faor all DBF_XXX calls*/
+	dasd_debug_area = debug_register (DASD_NAME, 
+                                          0,     /* size of debug area */
+                                          2,     /* number of areas */
+                                          8 * sizeof (long));
+
+	debug_register_view (dasd_debug_area, 
+                             &debug_sprintf_view);
+
 	if (dasd_debug_area == NULL) {
 		goto failed;
 	}
-	DASD_DRIVER_DEBUG_EVENT (0, dasd_init, "%s", 
-                                 "ENTRY");
-	dasd_devfs_handle = devfs_mk_dir (NULL, DASD_NAME, NULL);
+
+        debug_set_level (dasd_debug_area, 
+                         DBF_ERR);
+
+        DBF_EVENT (DBF_EMERG, "%s", 
+                   "debug area created");
+
+	dasd_devfs_handle = devfs_mk_dir (NULL, 
+                                          DASD_NAME, 
+                                          NULL);
+
 	if (dasd_devfs_handle < 0) {
-		DASD_DRIVER_DEBUG_EVENT (1, dasd_init, "%s", 
-                                         "no devfs");
+
+		DBF_EVENT (DBF_ALERT, "%s", 
+                           "no devfs");
 		goto failed;
 	}
-	list_for_each (l, &dasd_major_info[0].list) {
+
+        list_add_tail(&dasd_major_static.list, &dasd_major_info);
+	list_for_each (l, &dasd_major_info) {
 		major_info = list_entry (l, major_info_t, list);
 		if ((rc = dasd_register_major (major_info)) > 0) {
-			DASD_DRIVER_DEBUG_EVENT (1, dasd_init,
-						 "major %d: success",
-						 major_info->gendisk.major);
-			printk (KERN_INFO PRINTK_HEADER
-				"Registered successfully to major no %u\n",
-				major_info->gendisk.major);
+
+			MESSAGE (KERN_INFO,
+                                 "Registered successfully to major no %u",
+                                 major_info->gendisk.major);
 		} else {
-			DASD_DRIVER_DEBUG_EVENT (1, dasd_init,
-						 "major %d: failed",
-						 major_info->gendisk.major);
-			printk (KERN_WARNING PRINTK_HEADER
-				"Couldn't register successfully to major no %d\n",
-				major_info->gendisk.major);
+
+			MESSAGE (KERN_WARNING,
+                                 "Couldn't register successfully to "
+                                 "major no %d",
+                                 major_info->gendisk.major);
+
 			/* revert registration of major infos */
 			goto failed;
 		}
@@ -4185,29 +5374,38 @@
 #endif				/* ! MODULE */
 	rc = dasd_parse (dasd);
 	if (rc) {
-		DASD_DRIVER_DEBUG_EVENT (1, dasd_init, "%s",
-                                         "invalid range found");
+
+		DBF_EVENT (DBF_ALERT, "%s",
+                           "invalid range found");
 		goto failed;
 	}
 
+#ifdef CONFIG_PROC_FS
 	rc = dasd_proc_init ();
 	if (rc) {
-		DASD_DRIVER_DEBUG_EVENT (1, dasd_init, "%s", "no proc-FS");
+                
+		DBF_EVENT (DBF_ALERT, "%s", 
+                           "no proc-FS");
 		goto failed;
 	}
+#endif /* CONFIG_PROC_FS */
+
 	genhd_dasd_name = dasd_device_name;
-	genhd_dasd_ioctl = dasd_ioctl;
+        genhd_dasd_ioctl = dasd_ioctl;
 
 	if (dasd_autodetect) {	/* update device range to all devices */
 		for (irq = get_irq_first (); irq != -ENODEV;
 		     irq = get_irq_next (irq)) {
 			int devno = get_devno_by_irq (irq);
 			int index = dasd_devindex_from_devno (devno);
-			if (index == -ENODEV) {	/* not included in ranges */
-				DASD_DRIVER_DEBUG_EVENT (2, dasd_init,
-							 "add %04x to range",
-							 devno);
-				dasd_add_range (devno, devno, DASD_DEFAULT_FEATURES);
+			if (index < 0) {	/* not included in ranges */
+
+				DBF_EVENT (DBF_CRIT,
+                                           "add %04x to range",
+                                           devno);
+
+				dasd_add_range (devno, devno, 
+                                                DASD_FEATURE_DEFAULT);
 			}
 		}
 	}
@@ -4216,15 +5414,15 @@
 #ifdef CONFIG_DASD_DIAG
 		rc = dasd_diag_init ();
 		if (rc == 0) {
-			DASD_DRIVER_DEBUG_EVENT (1, dasd_init,
-						 "DIAG discipline %s",
-						 "success");
-			printk (KERN_INFO PRINTK_HEADER
-				"Registered DIAG discipline successfully\n");
+
+			MESSAGE (KERN_INFO, "%s",
+                                 "Registered DIAG discipline successfully");
+
 		} else {
-			DASD_DRIVER_DEBUG_EVENT (1, dasd_init,
-						 "DIAG discipline %s",
-						 "failed");
+
+			DBF_EVENT (DBF_ALERT, "%s",
+                                   "Register DIAG discipline failed");
+
 			goto failed;
 		}
 #endif /* CONFIG_DASD_DIAG */
